#
# ê黻饤֥ꡣhondana.orgΥǡȤ鷺marshal줿ѡ
#
# marshal.books ȤmarshalǡˤϽҾISBN򥭡ȤϢäƤꡢ
# marshal.shelfbooks ˤϡê̾򥭡ȤϢϿҥꥹȤäƤ롣
#
#    @@bookinfo[ISBN] = { 'authors' => '', 'title' => 'Perlˡ' }
#    @@shelf_books[''] = ['4123456789', '5123456789, ...]
#
# êܤоΤʤΤƱ黻᥽åɤѰդƤ
#
#             1   2   3   4   5   6   7   8
#   Aê    1                       1     1
#   Bê                      1     1     1     1     
#   Cê          1     1           1                 1
#

class Enzan
  @@bookinfo = nil
  @@shelf_books = nil
  @@book_shelves = nil

  def initialize
    if @@bookinfo == nil then
      File.open("marshal.bookinfo"){ |f|
        @@bookinfo = Marshal.load(f)
      }
      File.open("marshal.shelfbooks"){ |f|
        @@shelf_books = Marshal.load(f)
      }
      # ǡå - ɬפʤϤʤΤ
      @@shelf_books.each { |shelf,books|
        delbooks = []
        books.each { |book|
          if @@bookinfo[book].nil? then
            delbooks << book
          end
        }
        delbooks.each { |book|
          books.delete(book)
        }
      }

      # ܤбêꥹȺ
      @@book_shelves = {}
      @@shelf_books.each { |shelf,books|
        books.each { |book|
          @@book_shelves[book] = [] if @@book_shelves[book] == nil
          @@book_shelves[book].push(shelf)
        }
      }
    end
  end

  def bookinfo(isbn)
    @@bookinfo[isbn]
  end

  def books(shelf)
    @@shelf_books[shelf]
  end

  def collect_shelves
    @@shelf_books.collect { |shelf,books|
      yield shelf,books
    }
  end

  def shelves(book)
    @@book_shelves[book]
  end

  def collect_books
    @@book_shelves.collect { |book,shelves|
      yield book,shelves
    }
  end
end

class ShelfList
  def initialize(arg='')
    @enzan = Enzan.new
    @shelves = {}
    @list = []
    @isbn = ''
    if arg.class == String then
      # ShelfList.new('4488426034')
      @isbn = arg
      if @isbn != '' then
        @list = @enzan.shelves(@isbn)
        @list.each { |shelf|
          @shelves[shelf] = 1
        }
      end
    else
      # ShelfList.new(['','m'])
      @list = arg.to_a
      @list.each { |shelf|
        @shelves[shelf] = 1
      }
    end
  end

  def list(arg)
    @list[arg]
  end

  def [](arg)
    if arg.class == Fixnum then
      @list[arg]
    else
      ShelfList.new(@list[arg])
    end
  end

  def each
    @list.each { |shelf|
      yield shelf
    }
  end

  def count(shelf)
    @shelves[shelf].to_i
  end

  def major(thres=1)
    @shelves.each { |key,val|
      if val < thres then
        @list.delete(key)
        @shelves.delete(key)
      end
    }
    self
  end

  def add(sl)
    sl.each { |shelf|
      if @list.index(shelf).nil? then
        @list << shelf
      end
      @shelves[shelf] = @shelves[shelf].to_i + sl.count(shelf)
    }
    self
  end

  def sort
    @list.sort! { |a,b|
      @shelves[b] <=> @shelves[a]
    }
    self
  end

  def booklist
    bl = BookList.new
    @list.each { |shelf|
      bl.add(BookList.new(shelf))
    }
    bl
  end

  # êꥹȤˡֻܤܤ
  def similar
    set1 = Set.new(@list)
    similarlist = @enzan.collect_books { |book,shelves|
      set2 = Set.new(shelves)
      [book, set1.intersection(set2).length, set2.length]
    }.find_all { |v|
      v[2] != 0 && v[0] != @isbn
    }.collect { |v|
      [v[0], Float(v[1]) * 2.0 /Float(v[2]+set1.length), v[1]]
    }.sort { |a,b|
      b[1] <=> a[1]
    }.collect { |v|
      v[0]
    }
    BookList.new(similarlist)
  end

  def dump(n=10)
    @list.each { |shelf|
      puts "#{@shelves[shelf]} #{shelf}"
    }
  end
end

class BookList
  require 'set'
  include Enumerable

  def initialize(arg='')
    @enzan = Enzan.new
    @books = {}
    @list = []
    @name = ''
    if arg.class == String then
      # BookList.new('')
      @name = arg
      if @name != '' then
        @list = @enzan.books(@name)
        @list.each { |isbn|
          @books[isbn] = 1
        }
      end
    else
      # BookList.new(['4912345678','4923456789'])
      @list = arg.to_a
      @list.each { |isbn|
        @books[isbn] = 1
      }
    end
  end

  def list(arg)
    @list[arg]
  end

  def [](arg)
    if arg.class == Fixnum then
      @list[arg]
    else
      BookList.new(@list[arg])
    end
  end

  def each
    @list.each { |isbn|
      yield isbn
    }
  end

  def count(isbn)
    @books[isbn].to_i
  end

  def major(thres=1)
    @books.each { |key,val|
      if val < thres then
        @list.delete(key)
        @books.delete(key)
      end
    }
    self
  end

  def remove(bl)
    bl.each { |isbn|
      @list.delete(isbn)
      @books.delete(isbn)
    }
    self
  end

  def add(bl)
    bl.each { |isbn|
      if @list.index(isbn).nil? then
        @list << isbn
      end
      @books[isbn] = @books[isbn].to_i + bl.count(isbn)
    }
    self
  end

  def sort
    @list.sort! { |a,b|
      @books[b] <=> @books[a]
    }
    self
  end

  def shelflist
    sl = ShelfList.new
    @list.each { |isbn|
      sl.add(ShelfList.new(isbn))
    }
    sl
  end

  # ܥꥹȤˡֻêܤ
  def similar
    set1 = Set.new(@list)
    similarlist = @enzan.collect_shelves { |shelf,books|
      set2 = Set.new(books)
      [shelf, set1.intersection(set2).length, set2.length]
    }.find_all { |v|
      v[2] != 0 && v[0] != @name
    }.collect { |v|
      [v[0], Float(v[1]) * 2.0 /Float(v[2]+set1.length), v[1]]
    }.sort { |a,b|
      b[1] <=> a[1]
    }.collect { |v|
      v[0]
    }
    ShelfList.new(similarlist)
  end

  def dump(n=10)
    @list.each { |isbn|
      puts "#{@books[isbn]} #{isbn} #{@enzan.bookinfo(isbn)['title']} (#{@enzan.bookinfo(isbn)['authors']})"
    }
  end
end
